#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
	
def python_fu_sliced_for_guides_to_layers(image, layer, destin, tg, coor, del_guides):

	gimp.context_push()
	image.undo_group_start()
	
	guides = []
	next_guide = 0;
	next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	while next_guide != 0:
		guides.append(next_guide);
		next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
		
	offset_x,offset_y = pdb.gimp_drawable_offsets(layer)
	if tg==1:	# Create by center Vertical (x)
		for g in guides:
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_vguide(image,layer.width/2.0 + offset_x)	

	if tg==2:   # Create by center Horizontal (y)
		for g in guides:	
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_hguide(image,layer.height/2.0 + offset_y)	

	if tg==3:  	# Create by coordinate Vertical (x) 
		for g in guides:
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_vguide(image,coor + offset_x)	

	if tg==4:   # Create by coordinate Horizontal (y)
		for g in guides:
			pdb.gimp_image_delete_guide(image, g)
		pdb.gimp_image_add_hguide(image,coor + offset_y)
		
	selection = pdb.gimp_selection_bounds(image)
	x1 = selection[1];
	y1 = selection[2];
	x2 = selection[3];
	y2 = selection[4];	
	
#===================================================== Start code by Tin Tran ===========================
# guides_to_path.py download:https://gimplearn.net/viewtopic.php?f=3&t=52&p=62&hilit=Guides+To+path#p62

	guides = []
	next_guide = 0;
	next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	while next_guide != 0:
		guides.append(next_guide);
		next_guide = pdb.gimp_image_find_next_guide(image,next_guide);
	v_g = [];
	h_g = [];
	for guide in guides:
		guide_orientation = pdb.gimp_image_get_guide_orientation(image,guide);
		guide_position = pdb.gimp_image_get_guide_position(image,guide);
		if guide_orientation == 1: #vertical guide
			if (guide_position >= x1) and (guide_position <= x2): #if it's within the selected x-range
				v_g.append(guide_position);
		else: #horizontal guide
			if (guide_position >= y1) and (guide_position <= y2): #if it's within the selected y-range
				h_g.append(guide_position);
	
#========================================================== End code by Tin Tran ===========================
	
	parent = pdb.gimp_item_get_parent(layer)
	name = pdb.gimp_item_get_name(layer)
	position = pdb.gimp_image_get_item_position(image , layer)
	pdb.gimp_edit_copy(layer)
	copy = pdb.gimp_edit_paste(layer ,1)
	pdb.gimp_floating_sel_to_layer(copy)
	pdb.gimp_image_reorder_item(image ,copy ,parent ,position)
	pdb.gimp_item_set_visible(copy, 1)
	
	wi = pdb.gimp_image_width(image)
	hi = pdb.gimp_image_height(image)
	
	if destin==0:
		new_image = image
		
	if destin==1:
		new_image = pdb.gimp_image_new(wi, hi, 0)
		display = pdb.gimp_display_new(new_image)

	active_layer = pdb.gimp_layer_new_from_drawable(copy, new_image)
	pdb.gimp_image_insert_layer(new_image, active_layer, None, 0)
	active_layer.name = layer.name
	
	pdb.gimp_image_remove_layer(image, copy)
	
	pdb.gimp_selection_none(new_image)
	pdb.gimp_drawable_update(active_layer, 0, 0, active_layer.width, active_layer.height)
	if (len(v_g) > 0) or (len(h_g) == 0):

		l_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, l_layer, None, 1)
		pdb.gimp_image_select_rectangle(new_image, 2, 0, 0, v_g[x1], hi)
		pdb.gimp_edit_clear(l_layer)
		pdb.gimp_selection_none(new_image)

		r_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, r_layer, None, 1)
		pdb.gimp_image_select_rectangle(new_image, 2, 0, 0, v_g[x1], hi)
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(r_layer)
		
	if (len(v_g) == 0) or (len(h_g) > 0):
		t_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, t_layer, None, 1)
		pdb.gimp_image_select_rectangle(new_image, 2, 0, 0, wi, h_g[x1])
		pdb.gimp_edit_clear(t_layer)
		pdb.gimp_selection_none(new_image)

		b_layer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
		pdb.gimp_image_insert_layer(new_image, b_layer, None, 1)
		pdb.gimp_image_select_rectangle(new_image, 2, 0, 0, wi, h_g[x1])
		pdb.gimp_selection_invert(new_image)
		pdb.gimp_edit_clear(b_layer)

	pdb.gimp_selection_none(new_image)
	
	if destin==0:
		pdb.gimp_image_remove_layer(image, active_layer)

	if del_guides==1:
		for guide in guides:
			pdb.gimp_image_delete_guide(image, guide)
			
	image.undo_group_end()
	gimp.displays_flush()
	gimp.context_pop()

register (
	"python-fu-sliced-active-layer-using-guide",
	"Slice the ACTIVE LAYER using guide ",
	"Slice the active layer using guide",
	"MareroQ",
	"GPL",
	"2019",
	"Slice active layer using guide...",
	"*",
	[
	(PF_IMAGE, "image", "", None),
	(PF_DRAWABLE, "drawable", "", None),
	(PF_OPTION, "destin", "Slice Into Layers: ", 0, [" In Current Image "," In New Image " ]),
	(PF_OPTION, "tg", "Guide: ", 1, [" Use existing guide "," Create by center Vertical (x) "," Create by center Horizontal (y) "," Create by coordinate Vertical (x) "," Create by coordinate Horizontal (y) "]),
	(PF_SPINNER, "coor", "Coordinate (X or Y): ", 10, (0, 1000, 1)),
	(PF_TOGGLE,  "del_guides", "Deletle guides: ", 0 ),	
    ],
    [],
    python_fu_sliced_for_guides_to_layers, menu = "<Image>/Image/Transform"
    )

main()
