#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
import os, string, sys

def local_get_color_curves_presets_names():
	ret_list = []

	curvepresetfile =  "~/.config/GIMP/2.10/filters/GimpCurvesConfig.settings"
	curvepresetfile = os.path.expanduser(curvepresetfile)
	curvefile = open( u''+curvepresetfile,'r' )
	lines = curvefile.readlines( )
	for line in lines:
		if line.find('(GimpCurvesConfig "') > -1:
			start = line.find('"') + 1
			end = line.find('"',start)
			ret_list.append(line[start:end])
			
	curvefile.close()		
	
	#debug messages
	#pdb.gimp_message("get_color_curves_presets_names returns:")
	#pdb.gimp_message(ret_str)
	
	return (ret_list)
	
def readcurvefile_presetid(id):
	ret_lines = []
	curvepresetfile =  "~/.config/GIMP/2.10/filters/GimpCurvesConfig.settings"
	curvepresetfile = os.path.expanduser(curvepresetfile)
	curvefile = open( u''+curvepresetfile,'r' )
	lines = curvefile.readlines( )
	current_preset_id = -1
	found_it = False
	for line in lines:
		if found_it: #means we're still looking at the right preset_id lines
			ret_lines.append(line[4:]) #strip away the first 4 spaces 
		
		if line.find('(GimpCurvesConfig "') > -1:
			current_preset_id += 1
		if current_preset_id == id:
			found_it = True
		else:
			found_it = False
	curvefile.close()
	return (ret_lines)
def readcurvepresetfile(colorcurvepresetid):
  lines = readcurvefile_presetid(colorcurvepresetid)
  for line in lines:
      if line == "(channel value)\n": 
        nameCurve = "value"
      if line == "(channel red)\n": 
        nameCurve = "red"
      if line == "(channel green)\n": 
        nameCurve = "green"
      if line == "(channel blue)\n": 
        nameCurve = "blue"
      if line == "(channel alpha)\n": 
        nameCurve = "alpha"
      #if line.find("(curve-type smooth)") > -1:
      #  smooth = True
      #if line.find("(curve-type free)") > -1:
      #  smooth = False
      if line != "\n" and line.find("(") > -1:
        words = string.split( line )
        #if words[0] == "(points":
        if words[0] == "(samples": #Tin Tran use (samples instead of (points because (points didn't work for freehand curves)
          if nameCurve == "value":
            curve = words[2:]
          if nameCurve == "red":
            curvered = words[2:]
          if nameCurve == "green":
            curvegreen = words[2:]
          if nameCurve == "blue":
            curveblue = words[2:]
          if nameCurve == "alpha":
            curvealpha = words[2:]
  return curve, curvered, curvegreen, curveblue, curvealpha

def extractpoints( curve ):
  icurve= [];
  for curvestr in curve:
    #if curvestr[-1] == ")" :
    #  curvestr = curvestr[:-1]
    curvefloat = float( curvestr.rstrip(")") )
    curveint = (curvefloat * 255.0) #scale to [0,255]
    icurve.append( int( curveint ))
  return icurve
  #ibmax = len(icurve)-1
  #ib= 0
  #ixcurve= []
  #while ib <= ibmax:
    #if icurve[ ib ] != -255:
    # Suppress all XY points beginning by -255
    # Not sure what I am doing here but you can not introduce directly the gimpcurve in gimp_curves_splines, doesn't work
    # Tested like that and seem's to work correctly
    #ixcurve.append( icurve[ ib ] )
    #ixcurve.append( icurve[ ib+1 ] )
    #ib= ib +2
  #return ixcurve

  
  

def apply_color_curves_preset(image,layer,presetid):
	#curve, curvered, curvegreen, curveblue, curvealpha = readcurvepresetfile( presetid )
	curve, curvered, curvegreen, curveblue, curvealpha = readcurvepresetfile( presetid ) #Tin Tran not sure why alpha was previously ignored.
	icurve= extractpoints( curve )
	icurvered= extractpoints( curvered )
	icurvegreen= extractpoints( curvegreen )
	icurveblue= extractpoints( curveblue )
	icurvealpha = extractpoints( curvealpha )  #Tin tran not sure why alpha was ignored i am adding it in
    #apply curve information to current layer
	#if len(icurve) >= 4:
	#	pdb.gimp_curves_spline(layer, HISTOGRAM_VALUE, len(icurve), icurve )
	#if len(icurvered) >= 4:
	#	pdb.gimp_curves_spline(layer, HISTOGRAM_RED, len(icurvered), icurvered )
	#if len(icurvegreen) >= 4:
	#	pdb.gimp_curves_spline(layer, HISTOGRAM_GREEN, len(icurvegreen), icurvegreen )
	#if len(icurveblue) >= 4:
	#	pdb.gimp_curves_spline(layer, HISTOGRAM_BLUE, len(icurveblue), icurveblue )
	#if len(icurvealpha) >= 4:
	#	pdb.gimp_curves_spline(layer, HISTOGRAM_ALPHA, len(icurvealpha), icurvealpha )
	pdb.gimp_curves_explicit(layer, HISTOGRAM_VALUE, len(icurve), icurve )
	pdb.gimp_curves_explicit(layer, HISTOGRAM_RED, len(icurvered), icurvered )
	pdb.gimp_curves_explicit(layer, HISTOGRAM_GREEN, len(icurvegreen), icurvegreen )
	pdb.gimp_curves_explicit(layer, HISTOGRAM_BLUE, len(icurveblue), icurveblue )
	if pdb.gimp_drawable_has_alpha(layer): #if layer has alpha we apply alpha.
		pdb.gimp_curves_explicit(layer, HISTOGRAM_ALPHA, len(icurvealpha), icurvealpha )
		
register(
    "python_fu_apply_color_curves_preset",
    "Apply Color Curves from preset curve file",
    "Apply Color Curves Preset...",
    "Tin Tran altered Raymond Ostertag's code",
    "GPL",
    "2016",
    "<Image>/Tools/Apply Color Curves Preset...",
    "*",
    [
    #(PF_IMAGE, "image", "Input image", None), #current image
    #(PF_DRAWABLE, "layer", "Input layer", None), #current layer
    #(PF_FILENAME, "curvefilename","Curfile", dircurve ),
	(PF_OPTION,"presetid",   "Color Curves Preset:", 0, local_get_color_curves_presets_names()), # initially 0th is choice
	#(PF_INT, "presetid", "Color Curves Preset Id:", 0),
    ],
    [],
    apply_color_curves_preset)
	
main()
