#!/usr/bin/env python
# -*- coding: utf-8 -*-

from gimpfu import *
import os, string, sys

# i18n
#
dircurve = "~\\.gimp-2.8\\curves" #default searching pathname for curves
dircurve = os.path.expanduser( dircurve )
if not os.path.exists(dircurve ):
	dircurve = os.path.expanduser( "~" ) #otherwise start from user directory

def readcurvefile(
  curvefilename
  ):
  curvefile = open( u''+curvefilename,'r' )
  lines = curvefile.readlines( )
  if lines[0] == "# GIMP curves tool settings\n":
    for line in lines:
      if line == "(channel value)\n": 
        nameCurve = "value"
      if line == "(channel red)\n": 
        nameCurve = "red"
      if line == "(channel green)\n": 
        nameCurve = "green"
      if line == "(channel blue)\n": 
        nameCurve = "blue"
      if line == "(channel alpha)\n": 
        nameCurve = "alpha"
      if line != "\n" :
        words = string.split( line )
        if words[0] == "(points":
          if nameCurve == "value":
            curve = words[2:]
          if nameCurve == "red":
            curvered = words[2:]
          if nameCurve == "green":
            curvegreen = words[2:]
          if nameCurve == "blue":
            curveblue = words[2:]
          if nameCurve == "alpha":
            curvealpha = words[2:]
    return curve, curvered, curvegreen, curveblue # Alpha is ignored
  else:
    pdb.gimp_message("This is not a GIMP Curves File")
  curvefile.close()  


def extractpoints( curve ):
  icurve= [];
  for curvestr in curve:
    if curvestr[-1] == ")" :
      curvestr = curvestr[:-1]
    curvefloat = float( curvestr )
    curveint = (curvefloat * 255.0) #scale to [0,255]
    icurve.append( int( curveint ))
  ibmax = int( len(icurve) ) -1
  ib= 0
  ixcurve= []
  while ib <= ibmax:
    if icurve[ ib ] != -255:
    # Suppress all XY points beginning by -255
    # Not sure what I am doing here but you can not introduce directly the gimpcurve in gimp_curves_splines, doesn't work
    # Tested like that and seem's to work correctly
      ixcurve.append( icurve[ ib ] )
      ixcurve.append( icurve[ ib+1 ] )
    ib= ib +2
  return ixcurve

  
  

def apply_curve(image,layer,curvefilename):
	
	curve, curvered, curvegreen, curveblue = readcurvefile( curvefilename ) # Alpha is ignored
	icurve= extractpoints( curve )
	icurvered= extractpoints( curvered )
	icurvegreen= extractpoints( curvegreen )
	icurveblue= extractpoints( curveblue )
  
    #apply curve information to current layer
	if len(icurve) >= 4:
		pdb.gimp_curves_spline(layer, HISTOGRAM_VALUE, len(icurve), icurve )
	if len(icurvered) >= 4:
		pdb.gimp_curves_spline(layer, HISTOGRAM_RED, len(icurvered), icurvered )
	if len(icurvegreen) >= 4:
		pdb.gimp_curves_spline(layer, HISTOGRAM_GREEN, len(icurvegreen), icurvegreen )
	if len(icurveblue) >= 4:
		pdb.gimp_curves_spline(layer, HISTOGRAM_BLUE, len(icurveblue), icurveblue )
register(
    "python_fu_apply_curve",
    "Apply Color Curves from curve file",
    "Apply Curve...",
    "Tin Tran altered Raymond Ostertag's code",
    "GPL",
    "2016",
    "<Image>/Filters/Apply Curve...",
    "*",
    [
    #(PF_IMAGE, "image", "Input image", None), #current image
    #(PF_DRAWABLE, "layer", "Input layer", None), #current layer
    (PF_FILENAME, "curvefilename","Curfile", dircurve ),
    ],
    [],
    apply_curve)

main()