;script as described by PegLeg44 here: http://gimpchat.com/viewtopic.php?f=9&t=14046
;-----------------------------------------------------------------------------------
;I use the pen tool to select areas of the canvas (usually closed paths).
;1. I turn the path to a [Selection] [From Path].
;2. I create a new white layer.
;3. And fill the selection with black [Fill with Foreground Color].
;4. And then un-select [Select] [None].
;5. Then I run the [Colors] [Threshold] on the layer (with the standard 127 and 255 setting).
;6. And run [Layers] [Transparency] [Color to Alpha] on it.
;7. Then click the button [Lock Alpha Channel] at the top of the layers dockable dialog.
;8. Change the layer mode to [Darken Only]
;9. And finally use [Colors] [Invert] on it to make the black white.

(define (script-fu-apply-curve image layer 
            curvefilename
         )
	
		(let* 
		   (
		   (width (car (gimp-image-width image)))
		   (height (car (gimp-image-height image)))
		   (active-vectors 0)
		   (new-layer 0)
		   )
			;(gimp-image-undo-disable image); DN = NO UNDO
			(gimp-context-push)
			(gimp-image-undo-group-start image)                   ;undo-group in one step
			
			
			(gimp-message "Script Fu 's apply curve")
			(python-fu-apply-curve 1 image layer curvefilename)
		   ;(gimp-image-undo-enable image) ;DN = NO UNDO
			(gimp-image-undo-group-end image)                     ;undo group in one step
			(gimp-context-pop)
			(gimp-displays-flush)
	    )
	
	
    
) ;end of define
(script-fu-register
  "script-fu-apply-curve"         ;function name
  "<Image>/Script-Fu/Apply Curve..."    ;menu register
  "Apply Curve from Curve File"       ;description
  "Tin Tran"                          ;author name
  "copyright info and description"         ;copyright info or description
  "2016"                          ;date
  "RGB*, GRAY*"                        ;mode
  SF-IMAGE      "Image" 0                   
  SF-DRAWABLE   "Layer" 0
  SF-FILENAME   "Curve File" "~\\.gimp-2.8\\curves"
)
