#!/usr/bin/env python

# great_shuffle Rel 1
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
# Just trying to produce something that resembles the effect found here.
# http://gimpchat.com/viewtopic.php?f=8&t=14991
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math,random
import string
#import Image
from gimpfu import *
from array import array
import sys

def shuffle_column(col):
	#shuffle the left
	start_index = len(col)/4
	start_index = max(6,start_index + random.randint(-3,3)) - 6
	new_str = col[start_index+6:start_index+7] + \
		col[start_index:start_index+3] + col[start_index+7:start_index+9] + col[start_index+3:start_index+5] + \
		col[start_index+9:start_index+12] + col[start_index+5:start_index+6]
	col = col[0:start_index] + new_str + col[start_index+12:]
	#shuffle the right
	start_index = len(col)*3/4
	start_index = min(len(col)-6,start_index + random.randint(-3,3)) - 6
	new_str = col[start_index+6:start_index+7] + \
		col[start_index:start_index+3] + col[start_index+7:start_index+9] + col[start_index+3:start_index+5] + \
		col[start_index+9:start_index+12] + col[start_index+5:start_index+6]
	col = col[0:start_index] + new_str + col[start_index+12:]
	return col
	
	
	
def fresh_column(columns):
	col = []
	for i in range(0, int(columns)):
		col.append(i)
	return col

	
def python_great_shuffle(image, layer, rows, columns,horizontalwiggle,verticalwiggle,rotationwiggle) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	horizontalwiggle = int(horizontalwiggle)
	verticalwiggle = int(verticalwiggle)
	rotationwiggle = int(rotationwiggle)
	width = image.width/columns
	height = image.height/rows
	for yi in range(0,int(rows)):
		col = fresh_column(columns)
		col = shuffle_column(col)
		xcount = 0
		for xi in col:
			x = xi * width
			#x_end = x + width
			y = yi * height
			#y_end = y + height
			pdb.gimp_image_select_rectangle(image,CHANNEL_OP_REPLACE,x,y,width,height)
			pdb.gimp_edit_copy(layer)
			floating_sel = pdb.gimp_edit_paste(layer,0)
			pdb.gimp_floating_sel_to_layer(floating_sel)
			pdb.gimp_layer_translate(floating_sel,-(xi-xcount)*width,0)
			pdb.gimp_layer_translate(floating_sel,\
				random.randint(-(horizontalwiggle/2),-(horizontalwiggle/2)+ horizontalwiggle), \
				random.randint(-(verticalwiggle/2),-(verticalwiggle/2) + verticalwiggle))
			pdb.gimp_item_transform_rotate(floating_sel,math.pi*2*(random.randint(-(rotationwiggle/2),-(rotationwiggle/2) + rotationwiggle)/360.0)\
				,1,0,0)
			xcount += 1
			
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_great_shuffle",                           
	"performs great shuffle on layer",
	"performs great shuffle on layer...",
	"Tin Tran",
	"Tin Tran",
	"2016",
	"<Image>/Python-Fu/Great Shuffle...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "rows", "Number of Rows:", 5, (3, 10, 1)),
	(PF_SPINNER, "columns", "Number of Columns:", 46, (24, 100, 1)),
	(PF_SPINNER, "horizontalwiggle", "Horizontal Wiggle (pixels):", 5, (0, 100, 1)),
	(PF_SPINNER, "verticalwiggle", "Vertical Wiggle (pixels):", 5, (0, 100, 1)),
	(PF_SPINNER, "rotationwiggle", "Rotation Wiggle (degrees):", 5, (0, 360, 1)),
	],
	[],
	python_great_shuffle)

main()
