#!/usr/bin/env python
# coding=utf-8
# -*- encoding: utf-8 -*-
# lined_paths.py rel 4
# Created by Tin Tran
# Comments directed to http://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Use Paintbrush_default instead of Pencil for smoother lines.
# Rel 3: Added gradient colors option as skinnyhouse suggested.
# Rel 4: Create paths instead of drawing option.
# ======================== AUTOCOMPLETE HELP STARTS =============================
# ========================= while in atom editor can safely be removed
# try:
# 	#Try to set a variable to pdb, if it works then we're inside GIMP execution
# 	test = pdb
# except:
# 	#If it fails we're on our own so we'll use this for autocomplete
# 	try:
# 		import mypdb as pdb #import this file so that we bet pdb.* autocomplete
# 		from myenums import * #import this file so that we have ENUMS autocomplete
# 	except:
# 		pass
# ======================= AUTOCOMPLETE HELP ENDS ================================
import random
from gimpfu import *
import math

#main method
def python_lined_paths_tt(image, layer, lines, size, color,use_gradient,gradient,draw_paths):
	if use_gradient == 1:
		num_samples,colors = pdb.gimp_gradient_get_uniform_samples(gradient,int(lines),0)
	#pdb.gimp_image_undo_group_start(image)
	vectors1 = image.vectors[0]
	vectors2 = image.vectors[1]
	strokes1 = vectors1.strokes
	strokes2 = vectors2.strokes
	stroke1 = strokes1[0]
	stroke2 = strokes2[0]
	length1 = stroke1.get_length(0.01)-0.01
	length2 = stroke2.get_length(0.01)-0.01
	section1 = length1/(lines-1)
	section2 = length2/(lines-1)
	pdb.gimp_context_set_brush_size(size)
	pdb.gimp_context_set_foreground(color)
	if draw_paths == 1:
		vectors = pdb.gimp_vectors_new(image,"Lined-paths")
		pdb.gimp_image_insert_vectors(image,vectors,None,0)
	for i in range(0,int(lines)):
		dist1 = i * section1
		dist2 = i * section2
		x1,y1,slope1,valid1 = stroke1.get_point_at_dist(dist1,0.01)
		x2,y2,slope2,valid2 = stroke2.get_point_at_dist(dist2,0.01)
		if draw_paths == 0:
			if use_gradient == 1:
				pdb.gimp_context_set_foreground((colors[i*4],colors[i*4+1],colors[i*4+2]))
			pdb.gimp_paintbrush_default(layer,4,[x1,y1,x2,y2])
		else:
			stroke_id = pdb.gimp_vectors_stroke_new_from_points(vectors,0,12, \
				[x1,y1,x1,y1,x1,y1,x2,y2,x2,y2,x2,y2], 0)
			
	pdb.gimp_displays_flush()
	pdb.gimp_message("Complete!")
	#return

register(
	"python_fu_lined_paths_tt",
	"Criss-cross the paths with number of lines",
	"Criss-cross the paths with number of lines",
	"Tin Tran",
	"Tin Tran",
	"January 2019",
	"<Image>/Python-Fu/Lined Paths...",             #Menu path
	"RGB*, GRAY*",
	[
	(PF_SPINNER, "lines", "Number of Lines:", 50, (2, 5000, 1)),
	(PF_SPINNER, "size", "Size (pixels):", 1, (1, 200, 1)),
	(PF_COLOR, "color", "Lines Color:", (0, 0, 0) ),
	(PF_TOGGLE, "use_gradient","Use Colors from Gradient:", 0),
	(PF_GRADIENT, "gradient","Gradient:",0),
	(PF_TOGGLE, "draw_paths","Create Paths instead of drawing:", 0),
	],
	[],
	python_lined_paths_tt)

main()
