#!/usr/bin/env python

# magic_center_mix Release 8
# Created by Tin Tran (https://gimplearn.net/)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Copy transparency of original layer to all the RGB layers
# Rel 3: Added Magic Plus shape to the mix
# Rel 4: Added Magic Diamond shape to the mix
# Rel 5: Added Magic X shape to the mix
# Rel 6: Ability to select different shapes. Major bug found, use Polygon select instead of Rectangle select.
# Rel 7: Experimental version with base color.
# Rel 8: Fixed bug with base color calculation.
#import string
#import Image
import math
import random
from gimpfu import *

#from array import array
def python_ttc_square_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	#new_R = random.randrange(R,256)   # 200
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_R)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = (D)/2.0
	centery = (D)/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx-side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery+side/2.0+y*D,\
		centerx-side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	#new_G = random.randrange(G,256)   # 200
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_G)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = (D)/2.0
	centery = (D)/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx-side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery+side/2.0+y*D,\
		centerx-side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	#new_B = random.randrange(B,256)   # 200
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_B)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = (D)/2.0
	centery = (D)/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx-side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery-side/2.0+y*D,\
		centerx+side/2.0+x*D,centery+side/2.0+y*D,\
		centerx-side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	#pdb.gimp_selection_none(new_image)
	
	#pdb.gimp_edit_copy_visible(new_image)
	#pdb.gimp_display_delete(display)
    #return
def python_ttc_circle_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = min(D,(Total / float(new_R+0.001))**0.5)
	radius = ((Total/float(max(new_R,1)))/math.pi)**0.5
	side = radius * 2.0
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = float(D)/2
	centery = float(D)/2
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	#pdb.gimp_image_select_ellipse(new_image,CHANNEL_OP_REPLACE,centerx-side/2.0+x*D,centery-side/2.0+y*D,side,side)
	pdb.gimp_ellipse_select(new_image,centerx-side/2.0+x*D,centery-side/2.0+y*D,side,side,CHANNEL_OP_REPLACE,True,True,1)
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	#side = min(D,(Total / float(new_G+0.001))**0.5)
	radius = ((Total/float(max(new_G,1)))/math.pi)**0.5
	side = radius * 2.0
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_ellipse_select(new_image,centerx-side/2.0+x*D,centery-side/2.0+y*D,side,side,CHANNEL_OP_REPLACE,True,True,1)
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	#side = min(D,(Total / float(new_B+0.001))**0.5)
	radius = ((Total/float(max(new_B,1)))/math.pi)**0.5
	side = radius * 2.0
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		radius = ((D**2 - (math.pi*radius**2))/math.pi)**0.5
		side = radius * 2.0
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_ellipse_select(new_image,centerx-side/2.0+x*D,centery-side/2.0+y*D,side,side,CHANNEL_OP_REPLACE,True,True,1)
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
def python_ttc_triangle_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = min(D,(Total / float(new_R+0.001))**0.5)
	side = ((Total/float(max(new_R,1)))*2)**0.5
	
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,[D/2.0+x*D,centery - side/2.0+y*D,centerx-side/2.0+x*D,centery+side/2.0+y*D,centerx+side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	#side = min(D,(Total / float(new_G+0.001))**0.5)
	side = ((Total/float(max(new_G,1)))*2)**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,[D/2.0+x*D,centery - side/2.0+y*D,centerx-side/2.0+x*D,centery+side/2.0+y*D,centerx+side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	#side = min(D,(Total / float(new_B+0.001))**0.5)
	side = ((Total/float(max(new_B,1)))*2)**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	if (side > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (0.5 * side**2)))*2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,[D/2.0+x*D,centery - side/2.0+y*D,centerx-side/2.0+x*D,centery+side/2.0+y*D,centerx+side/2.0+x*D,centery+side/2.0+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
def python_ttc_plus_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_R)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	posx = random.randrange(0,2)
	posy = random.randrange(0,2)
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D         ,y*D,\
		 x*D+side/2.0,y*D,\
		 x*D+side/2.0,y*D+side/2.0,\
		 x*D         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D,\
		x*D+D-side/2.0+side/2.0,y*D,\
		x*D+D-side/2.0+side/2.0,y*D+side/2.0,\
		x*D+D-side/2.0         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D        ,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D         ,y*D+D-side/2.0+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D+D-side/2.0         ,y*D+D-side/2.0+side/2.0])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_G)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5

	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D         ,y*D,\
		 x*D+side/2.0,y*D,\
		 x*D+side/2.0,y*D+side/2.0,\
		 x*D         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D,\
		x*D+D-side/2.0+side/2.0,y*D,\
		x*D+D-side/2.0+side/2.0,y*D+side/2.0,\
		x*D+D-side/2.0         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D        ,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D         ,y*D+D-side/2.0+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D+D-side/2.0         ,y*D+D-side/2.0+side/2.0])
	
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_B)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D         ,y*D,\
		 x*D+side/2.0,y*D,\
		 x*D+side/2.0,y*D+side/2.0,\
		 x*D         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D,\
		x*D+D-side/2.0+side/2.0,y*D,\
		x*D+D-side/2.0+side/2.0,y*D+side/2.0,\
		x*D+D-side/2.0         ,y*D+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D        ,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0,\
		x*D+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D         ,y*D+D-side/2.0+side/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,8,\
		[x*D+D-side/2.0        ,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0,\
		x*D+D-side/2.0+side/2.0,y*D+D-side/2.0+side/2.0,\
		x*D+D-side/2.0         ,y*D+D-side/2.0+side/2.0])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	#pdb.gimp_selection_none(new_image)
	
	#pdb.gimp_edit_copy_visible(new_image)
	#pdb.gimp_display_delete(display)
    #return
def python_ttc_diamond_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(new_R,1)) / 2.0) ** 0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5
	if (side*2.0 > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5
	
	posx = random.randrange(0,2)
	posy = random.randrange(0,2)
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D+D/2.0-side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0-side,\
		x*D+D/2.0+side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0+side])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(new_G,1)) / 2.0) ** 0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5
	if (side*2.0 > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5

	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D+D/2.0-side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0-side,\
		x*D+D/2.0+side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0+side])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(new_B,1)) / 2.0) ** 0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5
	if (side*2.0 > D): #check final to make sure side isn't greater than D
		flip = not(flip)
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (max(0,(D**2 - (2*side**2))) / 2.0) ** 0.5
	
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[x*D+D/2.0-side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0-side,\
		x*D+D/2.0+side,y*D+D/2.0     ,\
		x*D+D/2.0     ,y*D+D/2.0+side])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
def python_ttc_x_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,paint):
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_R = 255 - paint[0]
	if max_R > R:
		new_R = random.randrange(R,max_R)
	else:
		new_R = R
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_R)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	side = side/2.0
	posx = random.randrange(0,2)
	posy = random.randrange(0,2)
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,\
		[x*D+D/2.0-side,y*D,\
		 x*D+D/2.0+side,y*D,\
		 x*D+D/2.0     ,y*D+side])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D     ,y*D+D/2.0-side,\
		 x*D+D     ,y*D+D/2.0+side,\
		 x*D+D-side,y*D+D/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D/2.0-side,y*D+D,\
		 x*D+D/2.0+side,y*D+D,\
		 x*D+D/2.0     ,y*D+D-side])	 
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D     ,y*D+D/2.0-side,\
		 x*D     ,y*D+D/2.0+side,\
		 x*D+side,y*D+D/2.0])	 
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_G = 255 - paint[1]
	if max_G > G:
		new_G = random.randrange(G,max_G)
	else:
		new_G = G
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_G)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	side = side/2.0

	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,\
		[x*D+D/2.0-side,y*D,\
		 x*D+D/2.0+side,y*D,\
		 x*D+D/2.0     ,y*D+side])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D     ,y*D+D/2.0-side,\
		 x*D+D     ,y*D+D/2.0+side,\
		 x*D+D-side,y*D+D/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D/2.0-side,y*D+D,\
		 x*D+D/2.0+side,y*D+D,\
		 x*D+D/2.0     ,y*D+D-side])	 
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D     ,y*D+D/2.0-side,\
		 x*D     ,y*D+D/2.0+side,\
		 x*D+side,y*D+D/2.0])	 
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	max_B = 255 - paint[2]
	if max_B > B:
		new_B = random.randrange(B,max_B)
	else:
		new_B = B
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_B)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	side = side/2.0
	
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,6,\
		[x*D+D/2.0-side,y*D,\
		 x*D+D/2.0+side,y*D,\
		 x*D+D/2.0     ,y*D+side])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D     ,y*D+D/2.0-side,\
		 x*D+D     ,y*D+D/2.0+side,\
		 x*D+D-side,y*D+D/2.0])
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D+D/2.0-side,y*D+D,\
		 x*D+D/2.0+side,y*D+D,\
		 x*D+D/2.0     ,y*D+D-side])	 
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_ADD,6,\
		[x*D     ,y*D+D/2.0-side,\
		 x*D     ,y*D+D/2.0+side,\
		 x*D+side,y*D+D/2.0])	 
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
def paint_base(new_image,base_layer,D,color,x,y):
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x*D,y*D,D,D)
	pdb.gimp_context_set_foreground(color)
	pdb.gimp_edit_fill(base_layer,FOREGROUND_FILL)
	
def python_tt_magic_center_mix(image, layer, D, Squares,Circles,Triangles,Diamonds,Xes,Plus,base):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_image_scale_full(image,image.width/D,image.height/D,INTERPOLATION_CUBIC)
	pdb.gimp_image_scale_full(image,image.width*D,image.height*D,INTERPOLATION_NONE)
	
	
	new_image = image
	#base color layer
	base_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,base_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(base_layer,True)
	pdb.gimp_item_set_name(base_layer, "Base Color Layer")
	pdb.gimp_layer_set_mode(base_layer,NORMAL_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(base_layer,FOREGROUND_FILL)
	#red layer
	red_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,red_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(red_layer,True)
	pdb.gimp_item_set_name(red_layer, "Red Layer")
	pdb.gimp_layer_set_mode(red_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	#green layer
	green_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,green_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(green_layer,True)
	pdb.gimp_item_set_name(green_layer, "Red Layer")
	pdb.gimp_layer_set_mode(green_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	#blue layer
	blue_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,blue_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(blue_layer,True)
	pdb.gimp_item_set_name(blue_layer, "Red Layer")
	pdb.gimp_layer_set_mode(blue_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	
	pdb.gimp_selection_none(image)
	#add ids to identify shapes by
	Shapes = []
	if Squares == 1: Shapes.append(1)
	if Circles == 1: Shapes.append(2)
	if Triangles == 1: Shapes.append(3)
	if Diamonds == 1: Shapes.append(4)
	if Xes == 1: Shapes.append(5)
	if Plus == 1: Shapes.append(6)
	
	for y in range(0,int(layer.height/D)):
		for x in range(0,int(layer.width/D)):
			num_channels,pixel = pdb.gimp_drawable_get_pixel(layer,x*D+1,y*D+1)
			min_factor = min(float(pixel[0])/max(base[0],0.01),float(pixel[1])/max(base[1],0.01),float(pixel[2])/max(base[2],0.01))

			#pdb.gimp_message(min_factor)
			new_factor = random.randrange(0,101)/100.0 * min_factor
			min_factor = new_factor
			#grab color to use as base paint
			paint = ((min(255,int(base[0]*min_factor))),(min(255,int(base[1]*min_factor))),(min(255,int(base[2]*min_factor))))
			pix = ((pixel[0]-paint[0]),(pixel[1]-paint[1]),(pixel[2]-paint[2]))
			paint_base(new_image,base_layer,D,paint,x,y)
			r = Shapes[random.randrange(0,len(Shapes))]
			if r == 1:
				python_ttc_square_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)
			elif r == 2:
				python_ttc_circle_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)
			elif r == 3:
				python_ttc_triangle_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)
			elif r == 4:
				python_ttc_diamond_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)
			elif r == 5:
				python_ttc_x_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)
			elif r == 6:
				python_ttc_plus_subroutine(D, pix[0], pix[1], pix[2],new_image,red_layer,green_layer,blue_layer,x,y,paint)

	pdb.gimp_selection_none(image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_tt_magic_center_mix",                           
	"Creates magic mix pixelization of active layer",
	"Creates magic mix pixelization of active layer",
	"Tin Tran",
	"Tin Tran",
	"July 2017",
	"<Image>/Diego/Magic Mix Center Position...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "D", "Dimension:", 20, (10, 100, 1)),
	(PF_TOGGLE, "Squares",   "Squares:", 1),
	(PF_TOGGLE, "Circles",   "Circles:", 1),
	(PF_TOGGLE, "Triangles",   "Triangles:", 1),
	(PF_TOGGLE, "Diamonds",   "Diamonds:", 1),
	(PF_TOGGLE, "Xes",   "X'es:", 1),
	(PF_TOGGLE, "Plus",   "Plus:", 1),
	(PF_COLOR, "base", "Base Color:", (255, 207, 187)),
	],
	[],
	python_tt_magic_center_mix)

main()
