#!/usr/bin/env python

# magic_plus Release 1
# Created by Tin Tran (https://gimplearn.net/)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import string
#import Image
import random
from gimpfu import *

#from array import array
def python_tt_plus_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y):
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_R = random.randrange(R,256)   # 200
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = min(D,(Total / float(new_R+0.001))**0.5)
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	posx = random.randrange(0,2)
	posy = random.randrange(0,2)
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x*D,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D,y*D+D-side/2.0,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D+D-side/2.0,side/2.0,side/2.0)
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_G = random.randrange(G,256)   # 200
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = min(D,(Total / float(new_G+0.001))**0.5)
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5

	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x*D,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D,y*D+D-side/2.0,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D+D-side/2.0,side/2.0,side/2.0)
	
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_B = random.randrange(B,256)   # 200
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = min(D,(Total / float(new_B+0.001))**0.5)
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	centerx = [side/2.0,D-side/2.0][posx]
	centery = [side/2.0,D-side/2.0][posy]
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D,D)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x*D,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D,y*D+D-side/2.0,side/2.0,side/2.0)
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_ADD,x*D+D-side/2.0,y*D+D-side/2.0,side/2.0,side/2.0)
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	#pdb.gimp_selection_none(new_image)
	
	#pdb.gimp_edit_copy_visible(new_image)
	#pdb.gimp_display_delete(display)
    #return
def python_tt_magic_plus(image, layer, D):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_image_scale_full(image,image.width/D,image.height/D,INTERPOLATION_CUBIC)
	pdb.gimp_image_scale_full(image,image.width*D,image.height*D,INTERPOLATION_NONE)
	
	
	new_image = image
	#red layer
	red_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,red_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(red_layer,True)
	pdb.gimp_item_set_name(red_layer, "Red Layer")
	pdb.gimp_layer_set_mode(red_layer,NORMAL_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	#green layer
	green_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,green_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(green_layer,True)
	pdb.gimp_item_set_name(green_layer, "Red Layer")
	pdb.gimp_layer_set_mode(green_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	#blue layer
	blue_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,blue_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(blue_layer,True)
	pdb.gimp_item_set_name(blue_layer, "Red Layer")
	pdb.gimp_layer_set_mode(blue_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	
	pdb.gimp_selection_none(image)
	#pdb.plug_in_pixelize(image,layer,D)
	for y in range(0,int(layer.height/D)):
		for x in range(0,int(layer.width/D)):
			#pdb.gimp_image_select_rectangle(image,CHANNEL_OP_REPLACE,x*D,y*D,D,D)
			num_channels,pixel = pdb.gimp_drawable_get_pixel(layer,x*D+1,y*D+1)
			python_tt_plus_subroutine(D, pixel[0], pixel[1], pixel[2],new_image,red_layer,green_layer,blue_layer,x,y)
			#floating_sel = pdb.gimp_edit_paste(layer,True)
			#pdb.gimp_floating_sel_anchor(floating_sel)
			
	pdb.gimp_selection_none(image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_tt_magic_plus",                           
	"Creates magic plus pixelization of active layer",
	"Creates magic plus pixelization of active layer",
	"Tin Tran",
	"Tin Tran",
	"July 2017",
	"<Image>/Diego/Magic Plus...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "D", "Dimension:", 20, (10, 100, 1)),
	],
	[],
	python_tt_magic_plus)

main()
