#!/usr/bin/env python

# magic_square_center_double_tile Release 3
# Created by Tin Tran (https://gimplearn.net/)
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
# Rel 2: Better randomness.
# Rel 3: Added 2x2 tile.
#import string
#import Image
import random
from gimpfu import *

#from array import array
def python_ttcd_square_subroutine(D, R, G, B, new_image, red_layer, green_layer, blue_layer,x,y,xcell,ycell):
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_R = random.randrange(R,256)   # 200
	color2 = (new_R,0,0)
	Total = float(R) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_R)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D*xcell,D*ycell)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx*xcell-side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D,\
		centerx*xcell-side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_G = random.randrange(G,256)   # 200
	color2 = (0,new_G,0)
	Total = float(G) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_G)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D*xcell,D*ycell)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx*xcell-side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D,\
		centerx*xcell-side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	
	
	#random value from minimum R to 255
	flip = random.randrange(0,100)>= 50
	color1 = (0,0,0)
	new_B = random.randrange(B,256)   # 200
	color2 = (0,0,new_B)
	Total = float(B) * D**2
	#side = ((D**2)*area_percentage)**0.5
	side = (Total / float(max(1,new_B)))**0.5
	if flip:
		tempcolor = color1
		color1 = color2
		color2 = tempcolor
		side = (D**2 - side**2)**0.5
	
	random_from = int(side/2.0 * 100)
	random_to = int((D - (side/2.0)) * 100)
	centerx = D/2.0
	centery = D/2.0
	if flip:
		pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,0+x*D,0+y*D,D*xcell,D*ycell)
		pdb.gimp_context_set_foreground(color1)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_image_select_polygon(new_image,CHANNEL_OP_REPLACE,8,\
		[centerx*xcell-side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell-side/2.0*ycell+y*D,\
		centerx*xcell+side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D,\
		centerx*xcell-side/2.0*xcell+x*D,centery*ycell+side/2.0*ycell+y*D])
	non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(new_image)
	if non_empty:
		pdb.gimp_context_set_foreground(color2)
		pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	#pdb.gimp_selection_none(new_image)
	
	#pdb.gimp_edit_copy_visible(new_image)
	#pdb.gimp_display_delete(display)
    #return
def python_ttcd_magic_square(image, layer, D):
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	pdb.gimp_image_scale_full(image,image.width/D,image.height/D,INTERPOLATION_CUBIC)
	pdb.gimp_image_scale_full(image,image.width*D,image.height*D,INTERPOLATION_NONE)
	new_image = image
	#red layer
	red_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,red_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(red_layer,True)
	pdb.gimp_item_set_name(red_layer, "Red Layer")
	pdb.gimp_layer_set_mode(red_layer,NORMAL_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(red_layer,FOREGROUND_FILL)
	#green layer
	green_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,green_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(green_layer,True)
	pdb.gimp_item_set_name(green_layer, "Red Layer")
	pdb.gimp_layer_set_mode(green_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(green_layer,FOREGROUND_FILL)
	#blue layer
	blue_layer = pdb.gimp_layer_new_from_drawable(layer,new_image)
	pdb.gimp_image_insert_layer(new_image,blue_layer,None,0)
	pdb.gimp_layer_set_lock_alpha(blue_layer,True)
	pdb.gimp_item_set_name(blue_layer, "Red Layer")
	pdb.gimp_layer_set_mode(blue_layer,ADDITION_MODE)
	pdb.gimp_selection_none(image)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(blue_layer,FOREGROUND_FILL)
	pdb.gimp_selection_none(image)
	#initialize grid to false
	grid = []
	for y in range(0,int(layer.height/D)):
		row = []
		for x in range(0,int(layer.width/D)):
			row.append(False)
		grid.append(row)
	search_range = 10 # if absolute value is within this range we make it 2 pixels
	
	for y in range(0,int(layer.height/D)-1):
		for x in range(0,int(layer.width/D)-1):
			num_channels,pixel1 = pdb.gimp_drawable_get_pixel(layer,x*D+1,y*D+1)
			if random.randrange(0,200) < 80:
				if not(grid[y][x]):
					num_channels,pixel2 = pdb.gimp_drawable_get_pixel(layer,x*D+1+D,y*D+1)
					num_channels,pixel3 = pdb.gimp_drawable_get_pixel(layer,x*D+1+D,y*D+1+D)
					num_channels,pixel4 = pdb.gimp_drawable_get_pixel(layer,x*D+1  ,y*D+1+D)
					if max(abs(pixel1[0]-pixel2[0]),abs(pixel1[1]-pixel2[1]),abs(pixel1[2]-pixel2[2])) <= search_range and \
						max(abs(pixel1[0]-pixel3[0]),abs(pixel1[1]-pixel3[1]),abs(pixel1[2]-pixel3[2])) <= search_range and \
						max(abs(pixel1[0]-pixel4[0]),abs(pixel1[1]-pixel4[1]),abs(pixel1[2]-pixel4[2])) <= search_range and \
						max(abs(pixel2[0]-pixel3[0]),abs(pixel2[1]-pixel3[1]),abs(pixel2[2]-pixel3[2])) <= search_range and \
						max(abs(pixel2[0]-pixel4[0]),abs(pixel2[1]-pixel4[1]),abs(pixel2[2]-pixel4[2])) <= search_range and \
						max(abs(pixel3[0]-pixel4[0]),abs(pixel3[1]-pixel4[1]),abs(pixel3[2]-pixel4[2])) <= search_range:
						grid[y][x] = True
						grid[y][x+1] = True
						grid[y+1][x] = True
						grid[y+1][x+1] = True
						pcolor = [(pixel1[0]+pixel2[0]+pixel3[0]+pixel4[0])/4,\
							(pixel1[1]+pixel2[1]+pixel3[1]+pixel4[1])/4,\
							(pixel1[2]+pixel2[2]+pixel3[2]+pixel4[2])/4]
						python_ttcd_square_subroutine(D, pcolor[0], pcolor[1], pcolor[2],new_image,red_layer,green_layer,blue_layer,x,y,2,2)
			if random.randrange(0,200) < 100: #do horizontal check first
				if random.randrange(0,200) < 80:
					if not(grid[y][x]) and not(grid[y][x+1]):
						num_channels,pixel2 = pdb.gimp_drawable_get_pixel(layer,x*D+1+D,y*D+1)
						if max(abs(pixel1[0]-pixel2[0]),abs(pixel1[1]-pixel2[1]),abs(pixel1[2]-pixel2[2])) <= search_range:
							grid[y][x] = True
							grid[y][x+1] = True
							pcolor = [(pixel1[0]+pixel2[0])/2,(pixel1[1]+pixel2[1])/2,(pixel1[2]+pixel2[2])/2]
							python_ttcd_square_subroutine(D, pcolor[0], pcolor[1], pcolor[2],new_image,red_layer,green_layer,blue_layer,x,y,2,1)
				if random.randrange(0,200) < 80:
					if not(grid[y][x]) and not(grid[y+1][x]):
						num_channels,pixel2 = pdb.gimp_drawable_get_pixel(layer,x*D+1  ,y*D+1+D)
						if max(abs(pixel1[0]-pixel2[0]),abs(pixel1[1]-pixel2[1]),abs(pixel1[2]-pixel2[2])) <= search_range:
							grid[y][x] = True
							grid[y+1][x] = True
							pcolor = ((pixel1[0]+pixel2[0])/2,(pixel1[1]+pixel2[1])/2,(pixel1[2]+pixel2[2])/2)
							python_ttcd_square_subroutine(D, pcolor[0], pcolor[1], pcolor[2],new_image,red_layer,green_layer,blue_layer,x,y,1,2)
			else: #do vertical check first
				if random.randrange(0,200) < 80:
					if not(grid[y][x]) and not(grid[y+1][x]):
						num_channels,pixel2 = pdb.gimp_drawable_get_pixel(layer,x*D+1  ,y*D+1+D)
						if max(abs(pixel1[0]-pixel2[0]),abs(pixel1[1]-pixel2[1]),abs(pixel1[2]-pixel2[2])) <= search_range:
							grid[y][x] = True
							grid[y+1][x] = True
							pcolor = ((pixel1[0]+pixel2[0])/2,(pixel1[1]+pixel2[1])/2,(pixel1[2]+pixel2[2])/2)
							python_ttcd_square_subroutine(D, pcolor[0], pcolor[1], pcolor[2],new_image,red_layer,green_layer,blue_layer,x,y,1,2)

				if random.randrange(0,200) < 80:
					if not(grid[y][x]) and not(grid[y][x+1]):
						num_channels,pixel2 = pdb.gimp_drawable_get_pixel(layer,x*D+1+D,y*D+1)
						if max(abs(pixel1[0]-pixel2[0]),abs(pixel1[1]-pixel2[1]),abs(pixel1[2]-pixel2[2])) <= search_range:
							grid[y][x] = True
							grid[y][x+1] = True
							pcolor = [(pixel1[0]+pixel2[0])/2,(pixel1[1]+pixel2[1])/2,(pixel1[2]+pixel2[2])/2]
							python_ttcd_square_subroutine(D, pcolor[0], pcolor[1], pcolor[2],new_image,red_layer,green_layer,blue_layer,x,y,2,1)
							
	for y in range(0,int(layer.height/D)):
		for x in range(0,int(layer.width/D)):
			if not (grid[y][x]):
				num_channels,pixel = pdb.gimp_drawable_get_pixel(layer,x*D+1,y*D+1)
				python_ttcd_square_subroutine(D, pixel[0], pixel[1], pixel[2],new_image,red_layer,green_layer,blue_layer,x,y,1,1)
	
	
	pdb.gimp_selection_none(image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_ttcd_magic_square",                           
	"Creates magic squares pixelization of active layer(double tile)",
	"Creates magic squares pixelization of active layer(double tile)",
	"Tin Tran",
	"Tin Tran",
	"July 2017",
	"<Image>/Diego/Squares Centered Double Tile...",             #Menu path
	"RGB*, GRAY*", 
	[
	(PF_SPINNER, "D", "Dimension:", 20, (10, 100, 1)),
	],
	[],
	python_ttcd_magic_square)

main()
