#!/usr/bin/env python

# palette-abs2.py
# Created by Tin Tran https://gimplearn.net
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
#import Image
from gimpfu import *
import random
import math
import os
def python_palette_abs2_tt(image,layer,palette,xtiles,ytiles) :
	pdb.gimp_image_undo_group_start(image)
	colors,colorvalues = pdb.gimp_palette_get_colors(palette)
	#colors = int(num_bytes/3)
	
	#creates a new image of same size and create a display for it.
	new_image = pdb.gimp_image_new(layer.width,layer.height,RGB)
	new_display = pdb.gimp_display_new(new_image)
	new_layer = pdb.gimp_layer_new(new_image,layer.width,layer.height,RGBA_IMAGE,"abs 2",100,LAYER_MODE_NORMAL)
	pdb.gimp_image_insert_layer(new_image,new_layer,None,0)
	
	xtiles = int(xtiles) #integer so we can loop
	ytiles = int(ytiles)
	
	for y in range(0,ytiles):
		pdb.gimp_progress_update(float(y)/ytiles)
		for x in range(0,xtiles):
			x1 = layer.width/xtiles * x
			x2 = layer.width/xtiles * (x+1)
			y1 = layer.height/ytiles * y
			y2 = layer.height/ytiles * (y+1)
			type = random.randrange(0,4)
			if type==0: #gradient left to right
				gx1 = x1
				gy1 = (y2+y1)/2
				gx2 = x2
				gy2 = gy1
			elif type==1: #gradient top left corner to opposite corner
				gx1 = x1
				gy1 = y1
				gx2 = x2
				gy2 = y2
			elif type==2: #gradient top to bottom
				gx1 = (x1+x2)/2
				gy1 = y1
				gx2 = gx1
				gy2 = y2
			elif type==3: #gradient top right corner to opposite corner
				gx1 = x2
				gy1 = y1
				gx2 = x1
				gy2 = y2
			pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,x1,y1,x2-x1,y2-y1)
			color1 = random.randrange(0,colors)
			color2 = random.randrange(0,colors)
			pdb.gimp_context_set_foreground(colorvalues[color1])
			pdb.gimp_context_set_background(colorvalues[color2])
			pdb.gimp_edit_blend(new_layer,BLEND_FG_BG_RGB,LAYER_MODE_NORMAL,GRADIENT_LINEAR,100,0,REPEAT_NONE,FALSE,FALSE,1,0,FALSE,gx1,gy1,gx2,gy2)

		pdb.gimp_displays_flush()
	pdb.gimp_selection_none(new_image)	
	#pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()


register(
	"python_fu_palette_abs2_tt",
	"Palette Abstract Rectangles",
	"Palette Abstract Rectangles",
	"Tin Tran",
	"Tin Tran",
	"November 2020",
	"<Image>/Python-Fu/Palette Abstract 2...",             #Menu path
	"RGB*, GRAY*, INDEXED*", 
	[
	#(PF_OPTION,"option",   "Mapping:", 0, ["To Circle","To Square"]),
	(PF_PALETTE, "palette", "Palette:", 0),
	(PF_SPINNER, "xtiles", "X-tiles:", 20, (2, 2000, 1)),
	(PF_SPINNER, "ytiles", "Y-tiles:", 20, (2, 2000, 1)),
	],
	[],
	python_palette_abs2_tt)

main()
