#!/usr/bin/env python

# rename_layers_for_animation Rel 1
# Created by Tin Tran
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import string
#import Image
from gimpfu import *
from array import array

def python_rename_layers_for_animation(image, layer, prefix, delay, replace, applyvisible) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	
	applylayers = []
	counter = 0
	for layer in image.layers[::-1]:
		counter += 1
		if (applyvisible == 0) or (layer.visible != 0): #user didn't check Only apply visible or if layer is visible.
			applylayers.append([layer,counter])
	
	#rename them all to some string that user would never be crazy enough to name before we apply real names to them.
	for applylayer in applylayers:
		applylayer[0].name = "Some String That User Would Never Be Crazy Enough To Name"
		
	#actual renaming of layers
	for applylayer in applylayers:
		layername = prefix + ' ' + str(applylayer[1]) + ' (' + str(int(delay)) + 'ms)'
		if replace != 0:
			layername = layername + ' (replace)'
		applylayer[0].name = layername
	
	
	
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
    "python_fu_rename_layers_for_animation",
    "Rename layers for animation",
    "Rename layers for animation...",
    "Tin Tran",
    "Tin Tran",
    "2014",
    "<Image>/AniTools/Rename Layers...",
    "RGB*, GRAY*", 
    [
	(PF_STRING, "prefix", "Layer Name Prefix:", "Frame"),
	(PF_SPINNER, "delay", "delay(ms):", 35, (1, 100000, 10)),
	(PF_TOGGLE, "replace",   "Add '(replace)' at the end to replace previous frame's content:", 0),
	(PF_TOGGLE, "applyvisible",   "Only Apply to visible layers:", 0),
	#(PF_COLOR, "oldcolor",  "Replace Color:",  (43,198,255)),
	#(PF_COLOR, "newcolor",  "With New Color:",  (255,198,0)),
	#(PF_SPINNER, "x1", "x1:", 0, (0, 100, 0.5)),
	#(PF_SPINNER, "y1", "y1:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "x2", "x2:", 100, (0, 100, 0.5)),
	#(PF_SPINNER, "y2", "y2:", 0, (0, 100, 0.5)),
	#(PF_COLOR, "black",  "Black point color",  (0,0,0) PF_FILE, "infilename", "Temp Filepath", "/Default/Path"),
	#(PF_COLOR, "white",  "White point color",  (255,255,255) ),
	#(PF_COLOR, "gray",  "Gray point color",  (128,128,128) )
	#(PF_FILE, "infilename", "Temp Filepath", "/Default/Path")
	#(PF_DIRNAME, "source_directory", "Source Directory", "") for some reason, on my computer when i(Tin) use PF_DIRNAME the pythonw.exe would crash
	],
    [],
    python_rename_layers_for_animation)

main()
