(define (script-fu-v-shape-selection-for-pegleg44 image layer 
			border-width-pixels
			color-curve-preset
         )
	
		(let* 
		   (
		   (width (car (gimp-image-width image)))
		   (height (car (gimp-image-height image)))
		   )
			;(gimp-image-undo-disable image); DN = NO UNDO
			(gimp-context-push)
			(gimp-image-undo-group-start image)                   ;undo-group in one step
			

		; 1. This first step would have to be interactive and have a dialog box to set the width of the resulting selection. [Select] [border] The feather would always be on, and the only part that needs to be interactive is the amount in pixels.
			(gimp-context-set-feather TRUE) ;seems to have no effect as border seem to feather always...hmmmm oh well that's what we want anyways so we're in luck
			(gimp-selection-border image border-width-pixels)
		;2. Go into Quick Mask Mode [Select] [Toggle Quick Mask].
            ;duplicate
			;add layer mask - selection
			;select all
			;apply curves
			;apply layer mask
			;delete duplicated layer
			;(define new-channel (car (gimp-channel-new image width height "selection" 0 '(0 0 0))))
			;(gimp-image-insert-channel image new-channel 0 0)
			
			;(define new-layer (car (gimp-layer-copy layer TRUE)))
			(define layer-copy layer)
			;(gimp-image-insert-layer image layer-copy 0 0)
			(define mask-selection (car (gimp-layer-create-mask layer-copy ADD-SELECTION-MASK)))
			(gimp-layer-add-mask layer-copy mask-selection)
			(gimp-selection-all image)
			;(gimp-layer-set-apply-mask layer-copy FALSE)
			(python-fu-apply-color-curves-preset 1 image mask-selection color-curve-preset)
			;(gimp-image-select-item image mask-selection CHANNEL-OP-REPLACE)
			;(gimp-layer-set-apply-mask layer-copy TRUE)
			(gimp-selection-load mask-selection)
			(gimp-layer-remove-mask layer-copy MASK-DISCARD)
			
		;3. Run a Curves preset that I have on my computer called RoundBlack [Colors] [Curves] [RoundBlack] - If this could NOT be interactive then that would be good, but if it has to be then it would be ok

		;4. Come out of Quick Mask Mode [Select] [Toggle Quick Mask]	
		   ;(gimp-image-undo-enable image) ;DN = NO UNDO
			(gimp-image-undo-group-end image)                     ;undo group in one step
			(gimp-context-pop)
			(gimp-displays-flush)
	    )
	
	
    
) ;end of define
(script-fu-register
  "script-fu-v-shape-selection-for-pegleg44"         ;function name
  "<Image>/HEIGHT TOOLS/Selection to Border (Interactive)"    ;menu register
  "Uses a Selection to Create a User Defined Border Selection"       ;description
  "Tin Tran"                          ;author name
  "copyright info and description"         ;copyright info or description
  "2016"                          ;date
  "RGB*, GRAY*"                        ;mode
  SF-IMAGE      "Image" 0                   
  SF-DRAWABLE   "Layer" 0
  ;SF-GRADIENT   "Gradient 1"           ""
  ;SF-GRADIENT   "Gradient 2"           ""
  SF-ADJUSTMENT   "Border width pixels" '(50 0 1000 1 10 0 0)
  SF-OPTION     "Color Curves Preset" (strbreakup (car (python-fu-get-color-curves-presets-names 1)) ",")
)
