; following Oregonian's tutorial on Double Bump Map
; found at link: http://gimpchat.com/viewtopic.php?f=23&t=12
; author: Tin Tran
; date: 2014
(define (script-fu-zoom image layer 
              map-to
			  generate-backside
			  iterations
         )
	(let* 
		(
		(dummy-variable-to-make-let-happy 0)
		(image-width)
		(image-height)
		(new-image-width)
		(new-image-height)
		(offset-x 0)
		(offset-y 0)
		(copied-layer)
		
		(i 0)  ;loop counter
		) ;end of variable declaration
		(gimp-context-push)
		(gimp-image-undo-group-start image)                   ;undo-group in one step

		(if (= map-to 2) ; if map-to is 2 set it to 3 to indicate cylinder
			(begin
				(set! map-to 3)
			)
			(begin ;else
			) 
		)
		(set! image-width (car (gimp-image-width image)))
		(set! image-height (car (gimp-image-height image)))
		(if (> map-to 0) ;if it's not plane 
			(begin
				(if (= generate-backside TRUE) ;if generate backside is ticked, run the reverse code
					(begin
						(set! new-image-width (+ image-width (* iterations 2)))
						(set! new-image-height (+ image-height (* iterations 2)))
						(gimp-image-resize image new-image-width new-image-height iterations iterations)
						(set! i 0)
						(while (< i iterations)
						
							(set! new-image-width (- new-image-width 2))
							(set! new-image-height (- new-image-height 2))
							
							;resize canvas
							(gimp-image-resize image new-image-width new-image-height -1 -1)
							
							;make copy of selected layer
							(set! copied-layer (car(gimp-layer-copy layer TRUE)))    ;copies the active layer
							;(gimp-image-insert-layer image copied-layer 0 (car (gimp-image-get-item-position image layer)))      ;insert the copied layer above active layer
							(gimp-image-insert-layer image copied-layer 0 0)
							(gimp-image-set-active-layer image copied-layer)
							
							;scale layer to new size
							(gimp-layer-scale copied-layer new-image-width new-image-height TRUE)
							
							;selects rectangle that is middle half
							(gimp-selection-all image)
							(plug-in-map-object 1 image copied-layer
														 map-to     ;1 sphere
														 0.5 0.5 2.0           ; viewpoint
						 0.5 0.5 0.0           ; object pos
						 1.0 0.0 0.0           ; first axis
						 0.0 1.0 0.0           ; 2nd axis
						 0.0 0.0 0.0            ; axis rotation
						 1 '(255 255 255)     ; Type of lightsource (0=point,1=directional,2=none)and Lightsource color (r,g,b)
						 -0.5 -0.5 2           ; light position
						 -1.0 -1.0 1.0        ; light direction
						 0.3 1.2 0.7 0.0 27.0 ; material (amb, diff, refl, spec, high)
						 TRUE               ; antialias
						 FALSE                ; tile
						 FALSE                ; new image
						 TRUE                ; transparency
						 .25                   ; Sphere/cylinder radius (only used when maptype=1 or 3)
						 0.25 0.25 0.25            ; box size
						 1.00                 ; unused parameter Cylinder length
						 -1                   ; Box front face (set these to -1 if not used)
						 -1                   ; Box back face
						 -1                   ; Box top face
						 -1                   ; Box bottom face
						 -1                   ; Box left face
						 -1                   ; Box right face
						 -1                   ; Cylinder top face (unused parameter)
						 -1)                  ; Cylinder bottom face (unused parameter)
														 
														 
														 
														 
																					   
							
							
							;(set! image-width new-image-width)
							;(set! image-height new-image-height)
							
							(set! i (+ i 1))
						)
					)
					(begin)
				)
			)
			(begin)
		)
		(set! new-image-width image-width)
		(set! new-image-height image-height)
		(set! i 0)
		(while (< i iterations)
		
			(set! new-image-width (+ 2 new-image-width))
			(set! new-image-height (+ 2 new-image-height))
			
			;resize canvas
			(gimp-image-resize image new-image-width new-image-height 1 1)
			
		    ;make copy of selected layer
			(set! copied-layer (car(gimp-layer-copy layer TRUE)))    ;copies the active layer
			;(gimp-image-insert-layer image copied-layer 0 (car (gimp-image-get-item-position image layer)))      ;insert the copied layer above active layer
			(gimp-image-insert-layer image copied-layer 0 0)
			(gimp-image-set-active-layer image copied-layer)
		    
			;scale layer to new size
			(gimp-layer-scale copied-layer new-image-width new-image-height TRUE)
			
			
			(if (> map-to 0) ;if it's not plane 
				(begin
					;selects rectangle that is middle half
					(gimp-image-select-rectangle image CHANNEL-OP-REPLACE 
													   (/ new-image-width 4)
													   0
													   (/ new-image-width 2)
													   new-image-height
													   )
					(gimp-selection-invert image)
					(gimp-edit-cut copied-layer)
					(gimp-selection-invert image)
				)
				(begin ;else it's just plane so we select the whole image.
					(gimp-selection-all image)
				)
			)
			(plug-in-map-object 1 image copied-layer
			                             map-to     ;1 sphere
										 0.5 0.5 2.0           ; viewpoint
         0.5 0.5 0.0           ; object pos
         1.0 0.0 0.0           ; first axis
         0.0 1.0 0.0           ; 2nd axis
         0.0 0.0 0.0            ; axis rotation
         1 '(255 255 255)     ; Type of lightsource (0=point,1=directional,2=none)and Lightsource color (r,g,b)
         -0.5 -0.5 2           ; light position
         -1.0 -1.0 1.0        ; light direction
         0.3 1.2 0.7 0.0 27.0 ; material (amb, diff, refl, spec, high)
         TRUE               ; antialias
         FALSE                ; tile
         FALSE                ; new image
         TRUE                ; transparency
         .25                   ; Sphere/cylinder radius (only used when maptype=1 or 3)
         0.25 0.25 0.25            ; box size
         1.00                 ; unused parameter Cylinder length
         -1                   ; Box front face (set these to -1 if not used)
         -1                   ; Box back face
         -1                   ; Box top face
         -1                   ; Box bottom face
         -1                   ; Box left face
         -1                   ; Box right face
         -1                   ; Cylinder top face (unused parameter)
         -1)                  ; Cylinder bottom face (unused parameter)
										 
										 
										 
										 
										 							   
			
			
			;(set! image-width new-image-width)
			;(set! image-height new-image-height)
			
			(set! i (+ i 1))
		)
		
		(gimp-image-undo-group-end image)                     ;undo group in one step
		(gimp-context-pop)
		(gimp-displays-flush)
	) ;end of let*
) ;end of define

(script-fu-register
  "script-fu-zoom"         ;function name
  "<Image>/Script-Fu/Sphere-Zoom"    ;menu register
  "Creates Spherical Zoom."       ;description
  "Tin Tran"                          ;author name
  "copyright info and description"         ;copyright info or description
  "2014"                          ;date
  "RGB*, GRAY*"                        ;mode
  SF-IMAGE      "Image" 0                   
  SF-DRAWABLE   "Layer" 0
  SF-OPTION     "Map to" '("Plane" "Sphere" "Cylinder")
  SF-TOGGLE     "Generate back side(for Sphere/Cyclinder)" FALSE
  SF-ADJUSTMENT "Map object iterations" '(10 1 50 1 5 0 0)
)